/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.client.collector;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.appspy.core.data.CollectedData;

/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public class SendTask implements Runnable {
	
	protected CollectorImpl mCollector = null;
	protected DataSender mDataSender = null;
	
	protected static Log mLog = LogFactory.getLog(SendTask.class);
	
	/**
	 * @return the collector
	 */
	public CollectorImpl getCollector() {
		return mCollector;
	}

	/**
	 * @param collector the collector to set
	 */
	public void setCollector(CollectorImpl collector) {
		mCollector = collector;
	}

	/**
	 * @return the dataSender
	 */
	public DataSender getDataSender() {
		return mDataSender;
	}

	/**
	 * @param dataSender the dataSender to set
	 */
	public void setDataSender(DataSender dataSender) {
		mDataSender = dataSender;
	}

	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		try
		{
			List<CollectedData> collectedDatas = mCollector.getCollectedDatas(true);
			if (mLog.isDebugEnabled())
			{
				mLog.debug("Sending : " + collectedDatas);
			}
			
			if (!collectedDatas.isEmpty())
			{
				mDataSender.sendData(collectedDatas);
			}
		} catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

}
